Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/libyahoo2.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -5087,233 +4853,566 @@
 	}
 
+	sfd->callback(id, fd, error, sfd->data);
+
 	yid->fd = fd;
-	yahoo_send_packet(yid, pkt, 8);
+	yid->read_tag =
+		YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->client_id, fd,
+		YAHOO_INPUT_READ, yid);
+}
+
+static void yahoo_file_transfer_upload(struct yahoo_data *yd,
+	struct send_file_data *sfd)
+{
+	char url[256];
+	char buff[4096];
+	char *sender_enc = NULL, *recv_enc = NULL, *token_enc = NULL;
+
+	struct yahoo_input_data *yid = y_new0(struct yahoo_input_data, 1);
+
+	yid->yd = yd;
+	yid->type = YAHOO_CONNECTION_FT;
+
+	inputs = y_list_prepend(inputs, yid);
+	sfd->yid = yid;
+	sfd->state = FT_STATE_SEND;
+
+	token_enc = yahoo_urlencode(sfd->token);
+	sender_enc = yahoo_urlencode(yd->user);
+	recv_enc = yahoo_urlencode(sfd->who);
+
+	snprintf(url, sizeof(url), 
+		"http://%s/relay?token=%s&sender=%s&recver=%s", sfd->ip_addr,
+		token_enc, sender_enc, recv_enc);
+
+	snprintf(buff, sizeof(buff), "T=%s; Y=%s", yd->cookie_t, yd->cookie_y);
+
+	yahoo_http_post(yd->client_id, url, buff, sfd->size,
+		_yahoo_ft_upload_connected, sfd);
+
+	FREE(token_enc);
+	FREE(sender_enc);
+	FREE(recv_enc);
+}
+
+static void yahoo_init_ft_recv(struct yahoo_data *yd,
+	struct send_file_data *sfd)
+{
+	char url[256];
+	char buff[1024];
+	char *sender_enc = NULL, *recv_enc = NULL, *token_enc = NULL;
+
+	struct yahoo_input_data *yid = y_new0(struct yahoo_input_data, 1);
+
+	yid->yd = yd;
+	yid->type = YAHOO_CONNECTION_FT;
+
+	inputs = y_list_prepend(inputs, yid);
+	sfd->yid = yid;
+	sfd->state = FT_STATE_HEAD;
+
+	token_enc = yahoo_urlencode(sfd->token);
+	sender_enc = yahoo_urlencode(sfd->who);
+	recv_enc = yahoo_urlencode(yd->user);
+
+	snprintf(url, sizeof(url), 
+		"http://%s/relay?token=%s&sender=%s&recver=%s", sfd->ip_addr,
+		token_enc, sender_enc, recv_enc);
+
+	snprintf(buff, sizeof(buff), "Y=%s; T=%s", yd->cookie_y, yd->cookie_t);
+
+	yahoo_http_head(yid->yd->client_id, url, buff, 0, NULL,
+		_yahoo_http_connected, yid);
+
+	FREE(token_enc);
+	FREE(sender_enc);
+	FREE(recv_enc);
+}
+
+static void yahoo_file_transfer_accept(struct yahoo_input_data *yid,
+	struct send_file_data *sfd)
+{
+	struct yahoo_packet *pkt;
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_Y7_FILETRANSFERACCEPT,
+		YPACKET_STATUS_DEFAULT, yid->yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, yid->yd->user);
+	yahoo_packet_hash(pkt, 5, sfd->who);
+	yahoo_packet_hash(pkt, 265, sfd->id);
+	yahoo_packet_hash(pkt, 27, sfd->filename);
+	yahoo_packet_hash(pkt, 249, "3");
+	yahoo_packet_hash(pkt, 251, sfd->token);
+
+	yahoo_send_packet(yid, pkt, 0);
+
 	yahoo_packet_free(pkt);
 
-	snprintf((char *)buff, sizeof(buff), "29");
-	buff[2] = 0xc0;
-	buff[3] = 0x80;
-	
-	write(yid->fd, buff, 4);
-
-	/*	YAHOO_CALLBACK(ext_yahoo_add_handler)(nyd->fd, YAHOO_INPUT_READ); */
-
-	sfd->callback(id, fd, error, sfd->user_data);
-	FREE(sfd);
-	inputs = y_list_remove(inputs, yid);
-	/*
-	while(yahoo_tcp_readline(buff, sizeof(buff), nyd->fd) > 0) {
-	if(!strcmp(buff, ""))
-	break;
-}
-
-	*/
-	yahoo_input_close(yid);
-}
-
-void yahoo_send_picture(int id, const char *name, unsigned long size,
-							yahoo_get_fd_callback callback, void *data)
-{
-	struct yahoo_data *yd = find_conn_by_id(id);
+	yahoo_init_ft_recv(yid->yd, sfd);
+}
+
+static void yahoo_process_filetransferaccept(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
+{
+	YList *l;
+	struct send_file_data *sfd;
+	char *who = NULL;
+	char *filename = NULL;
+	char *id = NULL;
+	char *token = NULL;
+
+	for (l = pkt->hash; l; l = l->next) {
+		struct yahoo_pair *pair = l->data;
+		switch (pair->key) {
+		case 4:
+			who = pair->value;
+			break;
+		case 5:
+			/* Me... don't care */
+			break;
+		case 249:
+			break;
+		case 265:
+			id = pair->value;
+			break;
+		case 251:
+			token = pair->value;
+			break;
+		case 27:
+			filename = pair->value;
+			break;
+		}
+	}
+
+	sfd = yahoo_get_active_transfer(id);
+
+	if (sfd) {
+		sfd->token = strdup(token);
+
+		yahoo_file_transfer_upload(yid->yd, sfd);
+	}
+	else {
+		YAHOO_CALLBACK(ext_yahoo_file_transfer_done)
+			(yid->yd->client_id, YAHOO_FILE_TRANSFER_UNKNOWN,
+			sfd ? sfd->data : NULL);
+
+		yahoo_remove_active_transfer(sfd);
+	}
+}
+
+static void yahoo_process_filetransferinfo(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
+{
+	YList *l;
+	char *who = NULL;
+	char *filename = NULL;
+	char *id = NULL;
+	char *token = NULL;
+	char *ip_addr = NULL;
+
+	struct send_file_data *sfd;
+
+	for (l = pkt->hash; l; l = l->next) {
+		struct yahoo_pair *pair = l->data;
+		switch (pair->key) {
+		case 1:
+		case 4:
+			who = pair->value;
+			break;
+		case 5:
+			/* Me... don't care */
+			break;
+		case 249:
+			break;
+		case 265:
+			id = pair->value;
+			break;
+		case 250:
+			ip_addr = pair->value;
+			break;
+		case 251:
+			token = pair->value;
+			break;
+		case 27:
+			filename = pair->value;
+			break;
+		}
+	}
+
+	sfd = yahoo_get_active_transfer(id);
+
+	if (sfd) {
+		sfd->token = strdup(token);
+		sfd->ip_addr = strdup(ip_addr);
+
+		yahoo_file_transfer_accept(yid, sfd);
+	}
+	else {
+		YAHOO_CALLBACK(ext_yahoo_file_transfer_done)
+			(yid->yd->client_id, YAHOO_FILE_TRANSFER_UNKNOWN,
+			sfd ? sfd->data : NULL);
+
+		yahoo_remove_active_transfer(sfd);
+	}
+}
+
+static void yahoo_send_filetransferinfo(struct yahoo_data *yd,
+	struct send_file_data *sfd)
+{
 	struct yahoo_input_data *yid;
-	struct yahoo_server_settings *yss;
+	struct yahoo_packet *pkt;
+
+	yid = find_input_by_id_and_type(yd->client_id, YAHOO_CONNECTION_PAGER);
+	sfd->ip_addr = YAHOO_CALLBACK(ext_yahoo_get_ip_addr)("relay.yahoo.com");
+
+	if (!sfd->ip_addr) {
+		YAHOO_CALLBACK(ext_yahoo_file_transfer_done)
+			(yd->client_id, YAHOO_FILE_TRANSFER_RELAY, sfd->data);
+
+		yahoo_remove_active_transfer(sfd);
+
+		return;
+	}
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_Y7_FILETRANSFERINFO,
+		YPACKET_STATUS_DEFAULT, yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, yd->user);
+	yahoo_packet_hash(pkt, 5, sfd->who);
+	yahoo_packet_hash(pkt, 265, sfd->id);
+	yahoo_packet_hash(pkt, 27, sfd->filename);
+	yahoo_packet_hash(pkt, 249, "3");
+	yahoo_packet_hash(pkt, 250, sfd->ip_addr);
+
+	yahoo_send_packet(yid, pkt, 0);
+
+	yahoo_packet_free(pkt);
+}
+
+static void yahoo_process_filetransfer(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
+{
+	YList *l;
+	char *who = NULL;
+	char *filename = NULL;
+	char *msg = NULL;
+	char *id = NULL;
+	int action = 0;
+	int size = 0;
+	struct yahoo_data *yd = yid->yd;
+
+	struct send_file_data *sfd;
+
+	for (l = pkt->hash; l; l = l->next) {
+		struct yahoo_pair *pair = l->data;
+		switch (pair->key) {
+		case 4:
+			who = pair->value;
+			break;
+		case 5:
+			/* Me... don't care */
+			break;
+		case 222:
+			action = atoi(pair->value);
+			break;
+		case 265:
+			id = pair->value;
+			break;
+		case 266: /* Don't know */
+			break;
+		case 302: /* Start Data? */
+			break;
+		case 300:
+			break;
+		case 27:
+			filename = pair->value;
+			break;
+		case 28:
+			size = atoi(pair->value);
+			break;
+		case 14:
+			msg = pair->value;
+		case 301: /* End Data? */
+			break;
+		case 303:
+			break;
+
+		}
+	}
+
+	if (action == YAHOO_FILE_TRANSFER_INIT) {
+		/* Received a FT request from buddy */
+		sfd = y_new0(struct send_file_data, 1);
+        
+		sfd->client_id = yd->client_id;
+		sfd->id = strdup(id);
+		sfd->who = strdup(who);
+		sfd->filename = strdup(filename);
+		sfd->size = size;
+        
+		yahoo_add_active_transfer(sfd);
+
+		YAHOO_CALLBACK(ext_yahoo_got_file) (yd->client_id, yd->user,
+			who, msg, filename, size, sfd->id);
+	}
+	else {
+		/* Response to our request */
+		sfd = yahoo_get_active_transfer(id);
+
+		if (sfd && action == YAHOO_FILE_TRANSFER_ACCEPT) {
+			yahoo_send_filetransferinfo(yd, sfd);
+		}
+		else if (!sfd || action == YAHOO_FILE_TRANSFER_REJECT) {
+			YAHOO_CALLBACK(ext_yahoo_file_transfer_done)
+				(yd->client_id, YAHOO_FILE_TRANSFER_REJECT,
+				sfd ? sfd->data : NULL);
+
+			yahoo_remove_active_transfer(sfd);
+		}
+	}
+}
+
+void yahoo_send_file(int id, const char *who, const char *msg,
+	const char *name, unsigned long size,
+	yahoo_get_fd_callback callback, void *data)
+{
 	struct yahoo_packet *pkt = NULL;
 	char size_str[10];
-	char expire_str[10];
-	long content_length=0;
-	unsigned char buff[1024];
-	char url[255];
+	struct yahoo_input_data *yid;
+	struct yahoo_data *yd;
 	struct send_file_data *sfd;
-
-	if(!yd)
-		return;
-
-	yss = yd->server_settings;
-
-	yid = y_new0(struct yahoo_input_data, 1);
-	yid->yd = yd;
-	yid->type = YAHOO_CONNECTION_FT;
-
-	pkt = yahoo_packet_new(YAHOO_SERVICE_PICTURE_UPLOAD, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	
+	yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	yd = find_conn_by_id(id);
+	sfd = y_new0(struct send_file_data, 1);
+
+	sfd->client_id = id;
+	sfd->id = yahoo_get_random();
+	sfd->who = strdup(who);
+	sfd->filename = strdup(name);
+	sfd->size = size;
+	sfd->callback = callback;
+	sfd->data = data;
+
+	yahoo_add_active_transfer(sfd);
+
+	if (!yd)
+		return;
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_Y7_FILETRANSFER,
+		YPACKET_STATUS_DEFAULT, yd->session_id);
 
 	snprintf(size_str, sizeof(size_str), "%ld", size);
-	snprintf(expire_str, sizeof(expire_str), "%ld", (long)604800);
-
-	yahoo_packet_hash(pkt, 0, yd->user);
+
 	yahoo_packet_hash(pkt, 1, yd->user);
-	yahoo_packet_hash(pkt, 14, "");
+	yahoo_packet_hash(pkt, 5, who);
+	yahoo_packet_hash(pkt, 265, sfd->id);
+	yahoo_packet_hash(pkt, 222, "1");
+	yahoo_packet_hash(pkt, 266, "1");
+	yahoo_packet_hash(pkt, 302, "268");
+	yahoo_packet_hash(pkt, 300, "268");
 	yahoo_packet_hash(pkt, 27, name);
 	yahoo_packet_hash(pkt, 28, size_str);
-	yahoo_packet_hash(pkt, 38, expire_str);
+	yahoo_packet_hash(pkt, 301, "268");
+	yahoo_packet_hash(pkt, 303, "268");
+
+	yahoo_send_packet(yid, pkt, 0);
+
+	yahoo_packet_free(pkt);
+}
+
+void yahoo_send_file_transfer_response(int client_id, int response, char *id, void *data)
+{
+	struct yahoo_packet *pkt = NULL;
+	char resp[2];
+	struct yahoo_input_data *yid;
 	
-
-	content_length = YAHOO_PACKET_HDRLEN + yahoo_packet_length(pkt);
-
-	snprintf(url, sizeof(url), "http://%s:%d/notifyft",
-				yss->filetransfer_host, yss->filetransfer_port);
-	snprintf((char *)buff, sizeof(buff), "Y=%s; T=%s",
-				 yd->cookie_y, yd->cookie_t);
-	inputs = y_list_prepend(inputs, yid);
-
-	sfd = y_new0(struct send_file_data, 1);
-	sfd->pkt = pkt;
-	sfd->callback = callback;
-	sfd->user_data = data;
-	yahoo_http_post(yid->yd->client_id, url, (char *)buff, content_length+4+size,
-						_yahoo_send_picture_connected, sfd);
-}
-
-static void _yahoo_send_file_connected(int id, int fd, int error, void *data)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_FT);
-	struct send_file_data *sfd = data;
-	struct yahoo_packet *pkt = sfd->pkt;
-	unsigned char buff[1024];
-
-	if(fd <= 0) {
-		sfd->callback(id, fd, error, sfd->user_data);
-		FREE(sfd);
-		yahoo_packet_free(pkt);
-		inputs = y_list_remove(inputs, yid);
-		FREE(yid);
-		return;
-	}
-
-	yid->fd = fd;
-	yahoo_send_packet(yid, pkt, 8);
+	struct send_file_data *sfd = yahoo_get_active_transfer(id);
+
+	sfd->data = data;
+
+	yid = find_input_by_id_and_type(client_id, YAHOO_CONNECTION_PAGER);
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_Y7_FILETRANSFER,
+		YPACKET_STATUS_DEFAULT, yid->yd->session_id);
+
+	snprintf(resp, sizeof(resp), "%d", response);
+
+	yahoo_packet_hash(pkt, 1, yid->yd->user);
+	yahoo_packet_hash(pkt, 5, sfd->who);
+	yahoo_packet_hash(pkt, 265, sfd->id);
+	yahoo_packet_hash(pkt, 222, resp);
+
+	yahoo_send_packet(yid, pkt, 0);
+
 	yahoo_packet_free(pkt);
 
-	snprintf((char *)buff, sizeof(buff), "29");
-	buff[2] = 0xc0;
-	buff[3] = 0x80;
+	if(response == YAHOO_FILE_TRANSFER_REJECT)
+		yahoo_remove_active_transfer(sfd);
+}
+
+static void yahoo_process_ft_connection(struct yahoo_input_data *yid, int over)
+{
+	struct send_file_data *sfd;
+	struct yahoo_data *yd = yid->yd;
 	
-	write(yid->fd, buff, 4);
-
-/*	YAHOO_CALLBACK(ext_yahoo_add_handler)(nyd->fd, YAHOO_INPUT_READ); */
-
-	sfd->callback(id, fd, error, sfd->user_data);
-	FREE(sfd);
-	inputs = y_list_remove(inputs, yid);
-	/*
-	while(yahoo_tcp_readline(buff, sizeof(buff), nyd->fd) > 0) {
-		if(!strcmp(buff, ""))
-			break;
-	}
-
-	*/
-	yahoo_input_close(yid);
-}
-
-void yahoo_send_file(int id, const char *who, const char *msg, 
-		const char *name, unsigned long size, 
-		yahoo_get_fd_callback callback, void *data)
+	sfd = yahoo_get_active_transfer_with_yid(yid);
+
+	if (!sfd) {
+		LOG(("Something funny happened. yid %p has no sfd.\n", yid));
+		return;
+	}
+
+	/* 
+	 * We want to handle only the complete data with HEAD since we don't
+	 * want a situation where both the GET and HEAD are active.
+	 * With SEND, we really can't do much with partial response
+	 */
+	if ((sfd->state == FT_STATE_HEAD || sfd->state == FT_STATE_SEND) 
+			&& !over)
+		return;
+
+	if (sfd->state == FT_STATE_HEAD) {
+		/* Do a GET */
+		char url[256];
+		char buff[1024];
+		char *sender_enc = NULL, *recv_enc = NULL, *token_enc = NULL;
+
+		struct yahoo_input_data *yid_ft = 
+			y_new0(struct yahoo_input_data, 1);
+        
+		yid_ft->yd = yid->yd;
+		yid_ft->type = YAHOO_CONNECTION_FT;
+        
+		inputs = y_list_prepend(inputs, yid_ft);
+		sfd->yid = yid_ft;
+		sfd->state = FT_STATE_RECV;
+
+		token_enc = yahoo_urlencode(sfd->token);
+		sender_enc = yahoo_urlencode(sfd->who);
+		recv_enc = yahoo_urlencode(yd->user);
+        
+		snprintf(url, sizeof(url), 
+			"http://%s/relay?token=%s&sender=%s&recver=%s", sfd->ip_addr,
+			token_enc, sender_enc, recv_enc);
+
+		snprintf(buff, sizeof(buff), "Y=%s; T=%s", yd->cookie_y,
+			yd->cookie_t);
+
+
+		yahoo_http_get(yd->client_id, url, buff, 1, 1,
+			_yahoo_http_connected, yid_ft);
+
+		FREE(token_enc);
+		FREE(sender_enc);
+		FREE(recv_enc);
+	}
+	else if (sfd->state == FT_STATE_RECV || 
+		sfd->state == FT_STATE_RECV_START) {
+
+		unsigned char *data_begin = NULL;
+
+		if (yid->rxlen == 0)
+			yahoo_remove_active_transfer(sfd);
+
+		if (sfd->state != FT_STATE_RECV_START &&
+			(data_begin = 
+				(unsigned char *)strstr((char *)yid->rxqueue,
+				"\r\n\r\n"))) {
+
+			sfd->state = FT_STATE_RECV_START;
+
+			yid->rxlen -= 4+(data_begin-yid->rxqueue)/sizeof(char);
+			data_begin += 4;
+
+			if (yid->rxlen > 0)
+				YAHOO_CALLBACK(ext_yahoo_got_ft_data) 
+					(yd->client_id, data_begin,
+					yid->rxlen, sfd->data);
+		}
+		else if (sfd->state == FT_STATE_RECV_START)
+			YAHOO_CALLBACK(ext_yahoo_got_ft_data) (yd->client_id,
+				yid->rxqueue, yid->rxlen, sfd->data);
+
+		FREE(yid->rxqueue);
+		yid->rxqueue = NULL;
+		yid->rxlen = 0;
+	}
+	else if (sfd->state == FT_STATE_SEND) {
+		/* Sent file completed */
+		int len = 0;
+		char *off = strstr((char *)yid->rxqueue, "Content-Length: ");
+
+		if (off) {
+			off += 16;
+			len = atoi(off);
+		}
+
+		if (len < sfd->size)
+			YAHOO_CALLBACK(ext_yahoo_file_transfer_done)
+				(yd->client_id,
+				YAHOO_FILE_TRANSFER_FAILED, sfd->data);
+		else
+			YAHOO_CALLBACK(ext_yahoo_file_transfer_done)
+				(yd->client_id,
+				YAHOO_FILE_TRANSFER_DONE, sfd->data);
+
+		yahoo_remove_active_transfer(sfd);
+	}
+}
+
+/* End File Transfer */
+
+enum yahoo_status yahoo_current_status(int id)
 {
 	struct yahoo_data *yd = find_conn_by_id(id);
-	struct yahoo_input_data *yid;
-	struct yahoo_server_settings *yss;
-	struct yahoo_packet *pkt = NULL;
-	char size_str[10];
-	long content_length=0;
-	unsigned char buff[1024];
-	char url[255];
-	struct send_file_data *sfd;
-
-	if(!yd)
-		return;
-
-	yss = yd->server_settings;
-
-	yid = y_new0(struct yahoo_input_data, 1);
-	yid->yd = yd;
-	yid->type = YAHOO_CONNECTION_FT;
-
-	pkt = yahoo_packet_new(YAHOO_SERVICE_FILETRANSFER, YAHOO_STATUS_AVAILABLE, yd->session_id);
-
-	snprintf(size_str, sizeof(size_str), "%ld", size);
-
-	yahoo_packet_hash(pkt, 0, yd->user);
-	yahoo_packet_hash(pkt, 5, who);
-	yahoo_packet_hash(pkt, 14, msg);
-	yahoo_packet_hash(pkt, 27, name);
-	yahoo_packet_hash(pkt, 28, size_str);
-
-	content_length = YAHOO_PACKET_HDRLEN + yahoo_packet_length(pkt);
-
-	snprintf(url, sizeof(url), "http://%s:%d/notifyft", 
-			yss->filetransfer_host, yss->filetransfer_port);
-	snprintf((char *)buff, sizeof(buff), "Y=%s; T=%s",
-			yd->cookie_y, yd->cookie_t);
-	inputs = y_list_prepend(inputs, yid);
-
-	sfd = y_new0(struct send_file_data, 1);
-	sfd->pkt = pkt;
-	sfd->callback = callback;
-	sfd->user_data = data;
-	yahoo_http_post(yid->yd->client_id, url, (char *)buff, content_length+4+size,
-			_yahoo_send_file_connected, sfd);
-}
-
-
-enum yahoo_status yahoo_current_status(int id)
-{
-	struct yahoo_data *yd = find_conn_by_id(id);
-	if(!yd)
+	if (!yd)
 		return YAHOO_STATUS_OFFLINE;
 	return yd->current_status;
 }
 
-const YList * yahoo_get_buddylist(int id)
+const YList *yahoo_get_buddylist(int id)
 {
 	struct yahoo_data *yd = find_conn_by_id(id);
-	if(!yd)
+	if (!yd)
 		return NULL;
 	return yd->buddies;
 }
 
-const YList * yahoo_get_ignorelist(int id)
+const YList *yahoo_get_ignorelist(int id)
 {
 	struct yahoo_data *yd = find_conn_by_id(id);
-	if(!yd)
+	if (!yd)
 		return NULL;
 	return yd->ignore;
 }
 
-const YList * yahoo_get_identities(int id)
+const YList *yahoo_get_identities(int id)
 {
 	struct yahoo_data *yd = find_conn_by_id(id);
-	if(!yd)
+	if (!yd)
 		return NULL;
 	return yd->identities;
 }
 
-const char * yahoo_get_cookie(int id, const char *which)
+const char *yahoo_get_cookie(int id, const char *which)
 {
 	struct yahoo_data *yd = find_conn_by_id(id);
-	if(!yd)
+	if (!yd)
 		return NULL;
-	if(!strncasecmp(which, "y", 1))
+	if (!strncasecmp(which, "y", 1))
 		return yd->cookie_y;
-	if(!strncasecmp(which, "t", 1))
+	if (!strncasecmp(which, "b", 1))
+		return yd->cookie_b;
+	if (!strncasecmp(which, "t", 1))
 		return yd->cookie_t;
-	if(!strncasecmp(which, "c", 1))
+	if (!strncasecmp(which, "c", 1))
 		return yd->cookie_c;
-	if(!strncasecmp(which, "login", 5))
+	if (!strncasecmp(which, "login", 5))
 		return yd->login_cookie;
 	return NULL;
 }
 
-void yahoo_get_url_handle(int id, const char *url, 
-		yahoo_get_url_handle_callback callback, void *data)
-{
-	struct yahoo_data *yd = find_conn_by_id(id);
-	if(!yd)
-		return;
-
-	yahoo_get_url_fd(id, url, yd, callback, data);
-}
-
-const char * yahoo_get_profile_url( void )
+const char *yahoo_get_profile_url(void)
 {
 	return profile_url;
 }
-
Index: protocols/yahoo/yahoo.c
===================================================================
--- protocols/yahoo/yahoo.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/yahoo.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -2,5 +2,5 @@
  * libyahoo2 wrapper to BitlBee
  *
- * Mostly Copyright 2004 Wilmer van der Gaast <wilmer@gaast.net>
+ * Mostly Copyright 2004-2010 Wilmer van der Gaast <wilmer@gaast.net>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -138,7 +138,12 @@
 	struct im_connection *ic = imcb_new( acc );
 	struct byahoo_data *yd = ic->proto_data = g_new0( struct byahoo_data, 1 );
+	char *s;
 	
 	yd->logged_in = FALSE;
 	yd->current_status = YAHOO_STATUS_AVAILABLE;
+	
+	if( ( s = strchr( acc->user, '@' ) ) && g_strcasecmp( s, "@yahoo.com" ) == 0 )
+		imcb_error( ic, "Your Yahoo! username should just be a username. "
+		                "Do not include any @domain part." );
 	
 	imcb_log( ic, "Connecting" );
@@ -153,5 +158,5 @@
 	
 	while( ic->groupchats )
-		imcb_chat_free( ic->groupchats );
+		imcb_chat_free( ic->groupchats->data );
 	
 	for( l = yd->buddygroups; l; l = l->next )
@@ -266,6 +271,30 @@
 {
 	struct byahoo_data *yd = (struct byahoo_data *) ic->proto_data;
-	
-	yahoo_add_buddy( yd->y2_id, who, group ? group : BYAHOO_DEFAULT_GROUP, NULL );
+	bee_user_t *bu;
+	
+	if( group && ( bu = bee_user_by_handle( ic->bee, ic, who ) ) && bu->group )
+	{
+		GSList *bgl;
+		
+		/* If the person is in our list already, this is a group change. */
+		yahoo_change_buddy_group( yd->y2_id, who, bu->group->name, group );
+		
+		/* No idea how often people have people in multiple groups and
+		   BitlBee doesn't currently support this anyway .. but keep
+		   this struct up-to-date for now. */
+		for( bgl = yd->buddygroups; bgl; bgl = bgl->next )
+		{
+			struct byahoo_buddygroups *bg = bgl->data;
+			
+			if( g_strcasecmp( bg->buddy, who ) == 0 &&
+			    g_strcasecmp( bg->group, bu->group->name ) == 0 )
+			{
+				g_free( bg->group );
+				bg->group = g_strdup( group );
+			}
+		}
+	}
+	else
+		yahoo_add_buddy( yd->y2_id, who, group ? group : BYAHOO_DEFAULT_GROUP, NULL );
 }
 
@@ -336,5 +365,5 @@
 	struct byahoo_data *yd = (struct byahoo_data *) ic->proto_data;
 	
-	yahoo_accept_buddy_ymsg13( yd->y2_id, NULL, who );
+	yahoo_confirm_buddy( yd->y2_id, who, 0, "" );
 }
 
@@ -343,5 +372,5 @@
 	struct byahoo_data *yd = (struct byahoo_data *) ic->proto_data;
 	
-	yahoo_reject_buddy_ymsg13( yd->y2_id, NULL, who, NULL );
+	yahoo_confirm_buddy( yd->y2_id, who, 1, "" );
 }
 
@@ -416,5 +445,5 @@
 	}
 	
-	d->callback( d->fd, 0, d->data );
+	d->callback( NULL + d->fd, 0, d->data );
 	g_free( d );
 }
@@ -436,5 +465,5 @@
 		return FALSE;
 	
-	yahoo_read_ready( d->id, d->fd, d->data );
+	yahoo_read_ready( d->id, NULL + d->fd, d->data );
 	
 	return TRUE;
@@ -453,5 +482,5 @@
 	struct byahoo_write_ready_data *d = data;
 	
-	return yahoo_write_ready( d->id, d->fd, d->data );
+	return yahoo_write_ready( d->id, NULL + d->fd, d->data );
 }
 
@@ -482,5 +511,5 @@
 	{
 		char *errstr;
-		int allow_reconnect = TRUE;
+		int allow_reconnect = FALSE;
 		
 		yd->logged_in = FALSE;
@@ -492,11 +521,13 @@
 		else if( succ == YAHOO_LOGIN_LOCK )
 			errstr = "Yahoo! account locked";
+		else if( succ == 1236 )
+			errstr = "Yahoo! account locked or machine temporarily banned";
 		else if( succ == YAHOO_LOGIN_DUPL )
+			errstr = "Logged in on a different machine or device";
+		else if( succ == YAHOO_LOGIN_SOCK )
 		{
-			errstr = "Logged in on a different machine or device";
-			allow_reconnect = FALSE;
+			errstr = "Socket problem";
+			allow_reconnect = TRUE;
 		}
-		else if( succ == YAHOO_LOGIN_SOCK )
-			errstr = "Socket problem";
 		else
 			errstr = "Unknown error";
@@ -601,15 +632,14 @@
 		flags = 0;
 		break;
-	case YAHOO_STATUS_NOTIFY:
-		state_string = "Notify";
-		break;
 	}
 	
 	imcb_buddy_status( ic, who, flags, state_string, msg );
 	
-	/* Not implemented yet...
 	if( stat == YAHOO_STATUS_IDLE )
-		imcb_buddy_times( ic, who, 0, away );
-	*/
+		imcb_buddy_times( ic, who, 0, idle );
+}
+
+void ext_yahoo_got_buzz( int id, const char *me, const char *who, long tm )
+{
 }
 
@@ -627,11 +657,18 @@
 }
 
-void ext_yahoo_got_file( int id,
-                         const char *ignored,
-                         const char *who, const char *url, long expires, const char *msg, const char *fname, unsigned long fesize )
+void ext_yahoo_got_file( int id, const char *ignored, const char *who, const char *msg,
+                         const char *fname, unsigned long fesize, char *trid )
 {
 	struct im_connection *ic = byahoo_get_ic_by_id( id );
 	
 	imcb_log( ic, "Got a file transfer (file = %s) from %s. Ignoring for now due to lack of support.", fname, who );
+}
+
+void ext_yahoo_got_ft_data( int id, const unsigned char *in, int len, void *data )
+{
+}
+
+void ext_yahoo_file_transfer_done( int id, int result, void *data )
+{
 }
 
@@ -646,5 +683,5 @@
 }
 
-void ext_yahoo_system_message( int id, const char *msg )
+void ext_yahoo_system_message( int id, const char *me, const char *who, const char *msg )
 {
 	struct im_connection *ic = byahoo_get_ic_by_id( id );
@@ -668,7 +705,8 @@
 
 /* TODO: Clear up the mess of inp and d structures */
-int ext_yahoo_add_handler( int id, int fd, yahoo_input_condition cond, void *data )
+int ext_yahoo_add_handler( int id, void *fd_, yahoo_input_condition cond, void *data )
 {
 	struct byahoo_input_data *inp = g_new0( struct byahoo_input_data, 1 );
+	int fd = (long) fd_;
 	
 	if( cond == YAHOO_INPUT_READ )
@@ -681,5 +719,5 @@
 		
 		inp->d = d;
-		d->tag = inp->h = b_input_add( fd, GAIM_INPUT_READ, (b_event_handler) byahoo_read_ready_callback, (gpointer) d );
+		d->tag = inp->h = b_input_add( fd, B_EV_IO_READ, (b_event_handler) byahoo_read_ready_callback, (gpointer) d );
 	}
 	else if( cond == YAHOO_INPUT_WRITE )
@@ -692,15 +730,15 @@
 		
 		inp->d = d;
-		d->tag = inp->h = b_input_add( fd, GAIM_INPUT_WRITE, (b_event_handler) byahoo_write_ready_callback, (gpointer) d );
+		d->tag = inp->h = b_input_add( fd, B_EV_IO_WRITE, (b_event_handler) byahoo_write_ready_callback, (gpointer) d );
 	}
 	else
 	{
 		g_free( inp );
-		return( -1 );
+		return -1;
 		/* Panic... */
 	}
 	
 	byahoo_inputs = g_slist_append( byahoo_inputs, inp );
-	return( inp->h );
+	return inp->h;
 }
 
@@ -726,5 +764,5 @@
 }
 
-int ext_yahoo_connect_async( int id, const char *host, int port, yahoo_connect_callback callback, void *data )
+int ext_yahoo_connect_async( int id, const char *host, int port, yahoo_connect_callback callback, void *data, int use_ssl )
 {
 	struct byahoo_connect_callback_data *d;
@@ -742,5 +780,33 @@
 	d->id = id;
 	
-	return( fd );
+	return fd;
+}
+
+char *ext_yahoo_get_ip_addr( const char *domain )
+{
+	return NULL;
+}
+
+int ext_yahoo_write( void *fd, char *buf, int len )
+{
+	return write( (long) fd, buf, len );
+}
+
+int ext_yahoo_read( void *fd, char *buf, int len )
+{
+	return read( (long) fd, buf, len );
+}
+
+void ext_yahoo_close( void *fd )
+{
+	close( (long) fd );
+}
+
+void ext_yahoo_got_buddy_change_group( int id, const char *me, const char *who,
+                                       const char *old_group, const char *new_group )
+{
+	struct im_connection *ic = byahoo_get_ic_by_id( id );
+	
+	imcb_add_buddy( ic, who, new_group );
 }
 
@@ -749,39 +815,4 @@
 int ext_yahoo_connect(const char *host, int port)
 {
-#if 0
-	struct sockaddr_in serv_addr;
-	static struct hostent *server;
-	static char last_host[256];
-	int servfd;
-	char **p;
-
-	if(last_host[0] || g_strcasecmp(last_host, host)!=0) {
-		if(!(server = gethostbyname(host))) {
-			return -1;
-		}
-		strncpy(last_host, host, 255);
-	}
-
-	if((servfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
-		return -1;
-	}
-
-	for (p = server->h_addr_list; *p; p++)
-	{
-		memset(&serv_addr, 0, sizeof(serv_addr));
-		serv_addr.sin_family = AF_INET;
-		memcpy(&serv_addr.sin_addr.s_addr, *p, server->h_length);
-		serv_addr.sin_port = htons(port);
-
-		if(connect(servfd, (struct sockaddr *) &serv_addr, 
-					sizeof(serv_addr)) == -1) {
-			return -1;
-		} else {
-			return servfd;
-		}
-	}
-
-	closesocket(servfd);
-#endif
 	return -1;
 }
@@ -790,9 +821,13 @@
 {
 	struct byahoo_conf_invitation *inv = data;
-	struct groupchat *b;
-	
-	for( b = inv->ic->groupchats; b; b = b->next )
+	struct groupchat *b = NULL;
+	GSList *l;
+	
+	for( l = inv->ic->groupchats; l; l = l->next )
+	{
+		b = l->data;
 		if( b == inv->c )
 			break;
+	}
 	
 	if( b != NULL )
@@ -827,4 +862,8 @@
 	char txt[1024];
 	YList *m;
+	
+	if( g_strcasecmp( who, ic->acc->user ) == 0 )
+		/* WTF, Yahoo! seems to echo these now? */
+		return;
 	
 	inv = g_malloc( sizeof( struct byahoo_conf_invitation ) );
@@ -856,7 +895,5 @@
 {
 	struct im_connection *ic = byahoo_get_ic_by_id( id );
-	struct groupchat *c;
-	
-	for( c = ic->groupchats; c && strcmp( c->title, room ) != 0; c = c->next );
+	struct groupchat *c = bee_chat_by_title( ic->bee, ic, room );
 	
 	if( c )
@@ -868,7 +905,5 @@
 {
 	struct im_connection *ic = byahoo_get_ic_by_id( id );
-	struct groupchat *c;
-	
-	for( c = ic->groupchats; c && strcmp( c->title, room ) != 0; c = c->next );
+	struct groupchat *c = bee_chat_by_title( ic->bee, ic, room );
 	
 	if( c )
@@ -880,7 +915,5 @@
 	struct im_connection *ic = byahoo_get_ic_by_id( id );
 	char *m = byahoo_strip( msg );
-	struct groupchat *c;
-	
-	for( c = ic->groupchats; c && strcmp( c->title, room ) != 0; c = c->next );
+	struct groupchat *c = bee_chat_by_title( ic->bee, ic, room );
 	
 	if( c )
@@ -893,5 +926,5 @@
 }
 
-void ext_yahoo_chat_join( int id, const char *who, const char *room, const char *topic, YList *members, int fd )
+void ext_yahoo_chat_join( int id, const char *who, const char *room, const char *topic, YList *members, void *fd )
 {
 }
@@ -921,16 +954,9 @@
 }
 
-void ext_yahoo_contact_auth_request( int id, const char *myid, const char *who, const char *msg )
-{
-	struct im_connection *ic = byahoo_get_ic_by_id( id );
-	
-	imcb_ask_auth( ic, who, NULL );
-}
-
 void ext_yahoo_contact_added( int id, const char *myid, const char *who, const char *msg )
 {
 	struct im_connection *ic = byahoo_get_ic_by_id( id );
 	
-	imcb_add_buddy( ic, (char*) who, NULL );
+	imcb_ask_auth( ic, who, msg );
 }
 
@@ -939,5 +965,5 @@
 }
 
-void ext_yahoo_game_notify( int id, const char *me, const char *who, int stat )
+void ext_yahoo_game_notify( int id, const char *me, const char *who, int stat, const char *msg )
 {
 }
@@ -984,5 +1010,5 @@
 }
 
-void ext_yahoo_got_ping( int id, const char *msg)
+void ext_yahoo_got_ping( int id, const char *msg )
 {
 }
